<?php

namespace NegarshopElementor\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_shop_carousel_Widget extends \Elementor\Widget_Base {

	public function get_name () {
		return 'negarshop_carousel';
	}

	public function get_title () {
		return 'کریوسل محصولات';
	}

	public function get_icon () {
		return 'eicon-gallery-grid';
	}

	public function get_categories () {
		return ['Negarshop_main'];
	}

	protected function _register_controls () {
		$this->start_controls_section('carousel_section', [
				'label' => 'تنظیمات کریوسل',
				'tab'   => Controls_Manager::TAB_CONTENT,
			]);
		$this->add_control('carousel_autoplay', [
				'label'   => 'پخش خودکار',
				'type'    => Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'true'  => 'فعال',
					'false' => 'غیرفعال'
				],
			]);
		$this->add_control('carousel_loop', [
				'label'   => 'حالت بینهایت',
				'type'    => Controls_Manager::SELECT,
				'default' => 'true',
				'options' => [
					'true'  => 'فعال',
					'false' => 'غیرفعال'
				],
			]);
		$this->add_control('carousel_nav', [
				'label'   => 'جهت ها',
				'type'    => Controls_Manager::SELECT,
				'default' => 'true',
				'options' => [
					'true'  => 'فعال',
					'false' => 'غیرفعال'
				],
			]);
		$this->add_control('carousel_items_xl', [
				'label'   => 'تعداد محصول نمایشی در حالت دسکتاپ',
				'type'    => Controls_Manager::NUMBER,
				'default' => 4,
			]);
		$this->add_control('carousel_items_lg', [
				'label'   => 'تعداد محصول نمایشی در حالت نمایشگر دسکتاپ متوسط',
				'type'    => Controls_Manager::NUMBER,
				'default' => 3,
			]);
		$this->add_control('carousel_items_md', [
				'label'   => 'تعداد محصول نمایشی در حالت تبلت',
				'type'    => Controls_Manager::NUMBER,
				'default' => 2,
			]);
		$this->add_control('carousel_items_xs', [
				'label'   => 'تعداد محصول نمایشی در حالت موبایل',
				'type'    => Controls_Manager::NUMBER,
				'default' => 2.5,
			]);
		$this->end_controls_section();
		$this->start_controls_section('content_section', [
				'label' => 'محتوا',
				'tab'   => Controls_Manager::TAB_CONTENT,
			]);

		$repeater = new \Elementor\Repeater();

		$repeater->add_control('tab_name', [
				'label'       => 'عنوان تب',
				'type'        => Controls_Manager::TEXT,
				'label_block' => true,
			]);
		$repeater->add_control('items_type', [
				'type'    => Controls_Manager::HIDDEN,
				'default' => 'products'
			]);
		$repeater->add_control('link', [
				'label'       => 'لینک آرشیو',
				'type'        => Controls_Manager::TEXT,
				'label_block' => true,
			]);
		$repeater->add_control('products_stock', [
				'label'   => 'وضعیت محصول',
				'type'    => Controls_Manager::SELECT,
				'default' => 'all',
				'options' => [
					'all'        => 'همه',
					'instock'    => 'فقط موجود ها',
					'outofstock' => 'نا موجود ها',
					'sale'       => 'فروش ویژه',
				],
			]);
		$repeater->add_control('products_type', [
			'label'   => 'کوئری نمایش محصولات',
			'type'    => Controls_Manager::SELECT,
			'default' => 'news',
			'options' => [
				'news'     => 'جدید ترین ها',
				'views'    => 'پربازدید ترین ها',
				'sell'     => 'پرفروش ترین ها',
				'archive'  => 'آرشیو کنونی',
				'category' => 'دسته بندی خاص',
				'tag'      => 'برچسب',
				'ids'      => 'شناسه محصولات',
			],
		]);
		$repeater->add_control('woo_categories', [
				'label'     => 'دسته بندی ها',
				'type'      => Controls_Manager::SELECT,
				'default'   => 0,
				'options'   => cb_get_categories('product_cat'),
				'condition' => [
					'products_type' => 'category',
				],
			]);
		$repeater->add_control('woo_tags', [
				'label'     => 'برچسب ها',
				'type'      => Controls_Manager::SELECT,
				'default'   => 0,
				'options'   => cb_get_categories('product_tag'),
				'condition' => [
					'products_type' => 'tag',
				],
			]);
		$repeater->add_control('product_ids', [
				'label'       => 'شناسه ها',
				'placeholder' => 'مثال: 1,2,3,4',
				'type'        => Controls_Manager::TEXT,
				'default'     => '',
				'condition'   => [
					'products_type' => 'ids',
				],
			]);
		$repeater->add_control('views_time', [
				'label'     => 'زمان بندی',
				'type'      => Controls_Manager::SELECT,
				'default'   => '7day',
				'options'   => [
					'7day'       => 'هفته',
					'month'      => 'این ماه',
					'last_month' => 'ماه گذشته',
					'year'       => 'سال',
				],
				'condition' => [
					'products_type' => 'views',
				],
			]);
		$repeater->add_control('sell_time', [
				'label'     => 'زمان بندی',
				'type'      => Controls_Manager::SELECT,
				'default'   => '7day',
				'options'   => [
					'7day'       => 'هفته',
					'month'      => 'این ماه',
					'last_month' => 'ماه گذشته',
					'year'       => 'سال',
				],
				'condition' => [
					'products_type' => 'sell',
				],
			]);
		$repeater->add_control('products_count', [
				'label'   => 'تعداد جهت نمایش',
				'type'    => Controls_Manager::NUMBER,
				'default' => 5,
			]);

		$this->add_control('tabs', [
				'label'       => 'تب ها',
				'type'        => Controls_Manager::REPEATER,
				'fields'      => $repeater->get_controls(),
				'default'     => [
					[
						'tab_name'       => 'مطالب جدید',
						'products_type'  => 'news',
						'products_count' => 5
					]
				],
				'title_field' => '{{{ tab_name }}}',
			]);


		$this->end_controls_section();



		$this->start_controls_section('style_section', [
			'label' => 'ظاهر',
			'tab'   => Controls_Manager::TAB_STYLE,
		]);
		$this->add_control('color_t', [
			'label'   => 'رنگ',
			'type'    => Controls_Manager::SELECT,
			'default' => 'default',
			'options' => [
				'default' => 'پیشفرض قالب',
				'custom'  => 'دستی',
			],
		]);
		$this->add_control('color', [
			'label'     => 'رنگ جعبه',
			'type'      => Controls_Manager::COLOR,
			'default'   => '#00bfd6',
			'selectors' => [
				'{{WRAPPER}} .products-carousel .loading .spinner'                                                     => 'border-top-color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel ul.tabs li a::after'                                                   => 'background-color: {{VALUE}}',
				'{{WRAPPER}} .btn-primary'                                                                             => 'background-color: {{VALUE}}; border-color: {{VALUE}}',
				'{{WRAPPER}} .ns-add-to-cart-inner .price-update'                                                      => 'color: {{VALUE}}',
				'{{WRAPPER}} .quantity.custom-num span:hover'                                                          => 'background-color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel article.item .actions ul li a:hover'                                   => 'background-color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel .tabs-count-1.style-2 ul.tabs::after'                                  => 'background-color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel article.w-p-item.product-item-style-2 .actions li.add-to-cart a:hover' => 'background-color: {{VALUE}} !important',
				'{{WRAPPER}} .products-carousel ul.tabs li.active a'                                                   => 'color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel article.w-p-item .info > .price span span'                             => 'color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel article.w-p-item .info > .price span.amount'                           => 'color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel a:not(.btn):hover'                                                     => 'color: {{VALUE}}',
				'{{WRAPPER}} .negarshop-countdown .countdown-section:last-of-type'                                     => 'color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel article.item .info > .price span span'                                 => 'color: {{VALUE}}',
				'{{WRAPPER}} .products-carousel article.item .info > .price span.amount'                               => 'color: {{VALUE}}',
			],
			'condition' => [
				'color_t' => 'custom',
			],
		]);

		$sizes      = get_all_image_sizes();
		$sizes_opts = [];
		foreach ( $sizes as $key => $val ) {
			$sizes_opts[$key] = $key . " (" . $val['width'] . " در " . $val['height'] . ")";
		}
		$this->add_control('card_image', [
			'label'   => 'اندازه تصویر کارت ها',
			'type'    => Controls_Manager::SELECT,
			'default' => 'sz_3_1',
			'options' => [
				             'custom' => 'دستی',
			             ] + $sizes_opts,
		]);
		$this->add_control('cs_image_width', [
			'label'     => 'طول',
			'type'      => Controls_Manager::NUMBER,
			'default'   => '300',
			'condition' => [
				'card_image' => 'custom',
			],
		]);
		$this->add_control('cs_image_height', [
			'label'     => 'عرض',
			'type'      => Controls_Manager::NUMBER,
			'default'   => '300',
			'condition' => [
				'card_image' => 'custom',
			],
		]);
		$this->add_control('style', [
			'label'   => 'طرح ابزارک',
			'type'    => Controls_Manager::SELECT,
			'default' => 'style-1',
			'options' => [
				'style-1' => 'طرح اول',
				'style-2' => 'طرح دوم',
			],
		]);

		$this->add_control('items_ribbon', [
			'label'   => 'وضعیت نمایش ریبون ها',
			'type'    => Controls_Manager::SELECT,
			'default' => 'true',
			'options' => [
				'true'  => 'فعال',
				'false' => 'غیرفعال',
			],
		]);
		$this->add_control('items_timer', [
			'label'   => 'وضعیت نمایش تایمر',
			'type'    => Controls_Manager::SELECT,
			'default' => 'false',
			'options' => [
				'true'  => 'فعال',
				'false' => 'غیرفعال',
			],
		]);
		$this->add_control('items_price', [
			'label'   => 'وضعیت نمایش قیمت محصول',
			'type'    => Controls_Manager::SELECT,
			'default' => 'true',
			'options' => [
				'true'  => 'فعال',
				'false' => 'غیرفعال',
			],
		]);
		$this->add_control('items_title', [
			'label'   => 'نمایش کامل عنوان',
			'type'    => Controls_Manager::SELECT,
			'default' => 'false',
			'options' => [
				'true'  => 'فعال',
				'false' => 'غیرفعال',
			],
		]);
		$this->add_control('one_price', [
			'label'   => 'نمایش قیمت نهایی',
			'type'    => Controls_Manager::SELECT,
			'default' => 'true',
			'options' => [
				'true'  => 'فعال',
				'false' => 'غیرفعال',
			],
		]);
		$this->add_control('item_actions', [
			'label'   => 'وضعیت نمایش دکمه ها',
			'type'    => Controls_Manager::SELECT,
			'default' => 'true',
			'options' => [
				'true'  => 'فعال',
				'false' => 'غیرفعال',
			],
		]);
		$this->add_control('item_colors', [
			'label'   => 'وضعیت نمایش رنگ بندی ها',
			'type'    => Controls_Manager::SELECT,
			'default' => 'false',
			'options' => [
				'true'  => 'فعال',
				'false' => 'غیرفعال',
			],
		]);
		$this->add_control('items_style', [
			'label'   => 'طرح کارت محصول',
			'type'    => Controls_Manager::SELECT,
			'default' => '1',
			'options' => [
				'1' => 'طرح اول',
				'2' => 'طرح دوم',
			],
		]);
		$this->add_control('items_vars', [
			'label'   => 'وضعیت نمایش متغیر های محصول',
			'type'    => Controls_Manager::SELECT,
			'default' => 'false',
			'options' => [
				'false' => 'غیرفعال',
				'1'     => '1',
				'2'     => '2',
				'3'     => '3',
				'4'     => '4',
				'5'     => '5',
			],
		]);
		$this->add_control('items_add_to_cart', [
			'label'   => 'نوع افزودن به سبد خرید',
			'type'    => Controls_Manager::SELECT,
			'default' => 'advanced',
			'options' => [
				'advanced' => 'حرفه ای',
				'simple'   => 'ساده',
				'link'     => 'لینک',
			],
		]);

		$this->end_controls_section();




		$this->start_controls_section('card_style_section', [
			'label' => 'کارت',
			'tab'   => Controls_Manager::TAB_STYLE,
		]);



		$this->start_controls_tabs('card_styles_section_tabs');

		$this->start_controls_tab( 'card_styles_section_normal', [
			'label' => 'پیشفرض',
		]);
		$this->add_control('card_bg', [
			'label'     => 'رنگ زمینه',
			'type'      => Controls_Manager::COLOR,
			'selectors' => [
				'{{WRAPPER}} article.w-p-item' => 'background-color: {{VALUE}}',
				'{{WRAPPER}} article.w-p-item .actions ul li' => 'background-color: {{VALUE}}',
				'{{WRAPPER}} article.w-p-item.product-item-style-2:hover .actions ul' => 'background-color: {{VALUE}} !important; box-shadow: {{VALUE}} -40px 0 30px 10px, {{VALUE}} -10px 0 0;',
			]
		]);
		$this->end_controls_tab();



		$this->start_controls_tab( 'card_styles_section_hover', [
			'label' => 'هاور',
		]);
		$this->add_control('card_bg_hover', [
			'label'     => 'رنگ زمینه',
			'type'      => Controls_Manager::COLOR,
			'selectors' => [
				'{{WRAPPER}} article.w-p-item:hover' => 'background-color: {{VALUE}}',
				'{{WRAPPER}} article.w-p-item:hover .actions ul li' => 'background-color: {{VALUE}}',
				'{{WRAPPER}} article.w-p-item.product-item-style-2:hover .actions ul' => 'background-color: {{VALUE}} !important; box-shadow: {{VALUE}} -40px 0 30px 10px, {{VALUE}} -10px 0 0;',
			]
		]);
		$this->end_controls_tab();



		$this->end_controls_tabs();

		$this->end_controls_section();




	}

	protected function render () {
		$settings                                          = $this->get_settings_for_display();
		$settings['id']                                    = $this->get_id();
		$settings['card_image_picker']['custom']['width']  = $settings['cs_image_width'];
		$settings['card_image_picker']['custom']['height'] = $settings['cs_image_height'];
		$settings['banner']                                = 'false';
		if ( !empty($settings['tabs']) ) {
			$tmp = [];
			foreach ( $settings['tabs'] as $items ) {
				$tmp2                                                                           = $items;
				$tmp2['items_type_picker']['products']['products_type_picker']['products_type'] = $items['products_type'];

				$tmp2['items_type_picker']['products']['products_type_picker']['category']['woo_categories'] = $items['woo_categories'];
				$tmp2['items_type_picker']['products']['products_type_picker']['tag']['woo_tags']            = $items['woo_tags'];
				$tmp2['items_type_picker']['products']['products_type_picker']['ids']['product_ids']         = $items['product_ids'];
				$tmp2['items_type_picker']['products']['products_type_picker']['views']['views_time']        = $items['views_time'];
				$tmp2['items_type_picker']['products']['products_type_picker']['sell']['sell_time']          = $items['sell_time'];
				$tmp2['items_type_picker']['products']['products_count']                                     = $items['products_count'];
				$tmp2['items_type_picker']['items_type']                                                     = $items['items_type'];

				$tmp[] = $tmp2;

			}
			$settings['tabs'] = $tmp;
		}
		ns_page_widget_carousel($settings, 'elementor');
	}

}
