<?php
namespace NegarshopElementor\Widgets;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_header_account_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return 'negarshop_header_account';
	}
	public function get_title() {
		return 'حساب کاربری';
	}
	public function get_icon() {
		return 'eicon-person';
	}
	public function get_categories() {
		return [ 'Negarshop_header' ];
	}
	protected function _register_controls() {
		$this->start_controls_section(
			'settings_section',
			[
				'label' => 'تنظیمات',
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'style',
			[
				'label' =>  'طرح',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'style-1',
				'options' => [
					'style-1' => 'طرح اول',
					'style-2' => 'طرح دوم',
					'style-2 style-3' => 'طرح سوم',
				],
			]
		);

		$this->add_control(
			'align',
			[
				'label' =>  'چینش',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'left',
				'options' => [
					'left' => 'چپ',
					'right' => 'راست',
					'center' => 'وسط',
				],
			]
		);

		$this->add_control(
			'color_mode',
			[
				'label' =>  'حالت رنگ',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'darken',
				'options' => [
					'darken' => 'تیره',
					'light' => 'روشن',
				],
			]
		);


		$repeater = new \Elementor\Repeater();

		$repeater->add_control(
			'title', [
				'label' => 'نام',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);
		$repeater->add_control(
			'link', [
				'label' => 'لینک',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);

		$this->add_control(
			'member_items',
			[
				'label' => 'منو های مهمان',
				'description' => 'این موارد فقط برای مهمان ها نمایش داده میشود!',
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [],
				'title_field' => '{{{ title }}}',
			]
		);


		$repeater2 = new \Elementor\Repeater();

		$repeater2->add_control(
			'title', [
				'label' => 'نام',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);
		$repeater2->add_control(
			'link', [
				'label' => 'لینک',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);

		$repeater2->add_control(
			'roles',
			[
				'label' => 'نمایش برای',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'all',
				'options' => [
					'user' => 'کاربر عادی',
					'vendor' => 'فروشنده',
					'all' => 'هر دو',
				],
			]
		);

		$this->add_control(
			'user_items',
			[
				'label' => 'منو های کاربران',
				'description' => 'این موارد فقط برای کاربران نمایش داده میشود!',
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater2->get_controls(),
				'default' => [],
				'title_field' => '{{{ title }}}',
			]
		);

		$this->end_controls_section();

	}
	protected function render() {
		$settings = $this->get_settings_for_display();
		$settings['id'] = $this->get_id();

		$args = [];
		$args['style']=$settings['style'];
		$args['member_items']=$settings['member_items'];
		$args['user_items']=$settings['user_items'];
		$args['cm']=$settings['color_mode'];
		ns_header_account($args,[
			'text-'.$settings['align']
		]);
	}

}
