<?php
namespace NegarshopElementor\Widgets;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_header_menu_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return 'negarshop_header_menu';
	}
	public function get_title() {
		return 'منوی اصلی';
	}
	public function get_icon() {
		return 'eicon-nav-menu';
	}
	public function get_categories() {
		return [ 'Negarshop_header' ];
	}
	protected function _register_controls() {
		$menus = wd_get_nav_menus_array();
		$this->start_controls_section(
			'settings_section',
			[
				'label' => 'تنظیمات',
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'use_ubermenu',
			[
				'label' =>  'استفاده از ubermenu',
				'type' => Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'false' => 'غیرفعال',
					'true' => 'فعال',
				],
			]
		);

		$this->add_control(
			'nav_style',
			[
				'label' =>  'طرح',
				'type' => Controls_Manager::SELECT,
				'default' => 'style-1',
				'options' => [
					'style-1' => 'طرح اول',
					'style-2' => 'طرح دوم',
				],
			]
		);

		$this->add_control(
			'bg_trans',
			[
				'label' =>  'زمینه شفاف',
				'type' => Controls_Manager::SELECT,
				'default' => 'colored',
				'options' => [
					'transparent' => 'فعال',
					'colored' => 'غیرفعال',
				],
			]
		);



		$this->add_control(
			'color_mode',
			[
				'label' =>  'حالت رنگ',
				'type' => Controls_Manager::SELECT,
				'default' => 'darken',
				'options' => [
					'darken' => 'تیره',
					'light' => 'روشن',
				],
			]
		);

		$this->add_control(
			'logo_ac',
			[
				'label' =>  'لوگو',
				'type' => Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'true' => 'فعال',
					'false' => 'غیرفعال',
				],
			]
		);

		$this->add_control(
			'logo_type',
			[
				'label' =>  'نوع لوگو',
				'type' => Controls_Manager::SELECT,
				'default' => 'text',
				'options' => [
					'text' => 'متن',
					'image' => 'عکس',
				],
				'condition' => [
					'logo_ac' => 'true',
				],
			]
		);
		$this->add_control(
			'logo_text',
			[
				'label'=>   'متن',
				'type' => Controls_Manager::TEXT,
				'default' => get_bloginfo('name'),
				'condition' => [
					'logo_type' => 'text',
					'logo_ac' => 'true',
				],
			]
		);
		$this->add_control(
			'logo_image',
			[
				'label' =>  'عکس',
				'type' => Controls_Manager::MEDIA,
				'default' => [
					'url' => get_theme_file_uri( '/statics/images/logo.png' )
				],
				'condition' => [
					'logo_type' => 'image',
					'logo_ac' => 'true',
				],
			]
		);
		$this->add_control(
			'logo_link',
			[
				'label'=>   'لینک',
				'type' => Controls_Manager::TEXT,
				'default' => site_url(),
				'condition' => [
					'logo_ac' => 'true',
				],
			]
		);

		$this->add_control(
			'cat_menu_ac',
			[
				'label' =>  'فهرست دسته بندی ها',
				'type' => Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'true' => 'فعال',
					'false' => 'غیرفعال',
				],
			]
		);
		$this->add_control(
			'menu_title',
			[
				'label'=>   'متن منو',
				'type' => Controls_Manager::TEXT,
				'default' => 'دسته بندی ها',
				'condition' => [
					'cat_menu_ac' => 'true',
				],
			]
		);
		$this->add_control(
			'cat_menu',
			[
				'label' =>  'انتخاب منو',
				'type' => Controls_Manager::SELECT,
				'default' => false,
				'options' => $menus,
				'condition' => [
					'cat_menu_ac' => 'true',
				],
			]
		);

		$this->add_control(
			'main_menu_ac',
			[
				'label' =>  'فهرست اصلی',
				'type' => Controls_Manager::SELECT,
				'default' => 'true',
				'options' => [
					'true' => 'فعال',
					'false' => 'غیرفعال',
				],
			]
		);
		$this->add_control(
			'main_menu',
			[
				'label' =>  'انتخاب منو',
				'type' => Controls_Manager::SELECT,
				'default' => false,
				'options' => $menus,
				'condition' => [
					'main_menu_ac' => 'true',
				],
			]
		);
		$this->add_control(
			'main_align',
			[
				'label' =>  'چینش',
				'type' => Controls_Manager::SELECT,
				'default' => 'right',
				'options' => [
					'left' => 'چپ',
					'right' => 'راست',
					'center' => 'وسط',
				],
			]
		);



		$this->end_controls_section();



		$this->start_controls_section(
			'style_settings_section',
			[
				'label' => 'اصلی',
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_control(
			'menu_bg',
			[
				'label' => 'رنگ زمینه منو',
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .header-main-nav' => 'background: {{VALUE}} !important',
				],
			]
		);

		$this->add_control(
			'menu_text',
			[
				'label' => 'رنگ متن منو',
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .header-main-nav .header-main-menu > ul > li > a:not(:hover)' => 'color: {{VALUE}} !important',
				],
			]
		);
		$this->add_control(
			'menu_text_hover',
			[
				'label' => 'رنگ متن منو حالت هاور',
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .header-main-nav .header-main-menu > ul > li:hover > a' => 'color: {{VALUE}} !important',
					'{{WRAPPER}} .header-main-nav .header-main-menu > ul > li.loading > a::after' => 'background-color: {{VALUE}} !important',
					'{{WRAPPER}} .header-main-nav .header-main-menu > ul > li.loaded > a::after' => 'background-color: {{VALUE}} !important',
					'{{WRAPPER}} li a.loading::before' => 'background-color: {{VALUE}} !important',
				],
			]
		);

		$this->end_controls_section();


		$this->start_controls_section(
			'submenu_style_settings_section',
			[
				'label' => 'زیر منو ها',
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_control(
			'submenu_bg',
			[
				'label' => 'رنگ زمینه',
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .header-main-nav .header-main-menu li > ul' => 'background-color: {{VALUE}};',
				],
			]
		);

		$this->add_control(
			'submenu_text',
			[
				'label' => 'رنگ متن',
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .header-main-nav .header-main-menu li > ul a' => 'color: {{VALUE}}',
					'{{WRAPPER}} .header-main-nav .header-main-menu li > ul li.menu-item-has-children > a::after' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'submenu_text_hover',
			[
				'label' => 'رنگ متن حالت هاور',
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .header-main-nav .header-main-menu li > ul a:hover' => 'color: {{VALUE}}',
					'{{WRAPPER}} .header-main-nav .header-main-menu li > ul li.menu-item-has-children > a:hover::after' =>	'color: {{VALUE}}'
				],
			]
		);

		$this->end_controls_section();
	}
	protected function render() {
		$settings = $this->get_settings_for_display();
		$settings['id'] = $this->get_id();

		$nav_args = array();
		if($settings['logo_ac'] === "true"){
			$logo_type = $settings['logo_type'];
			$logo_type_picker = [
				'logo_type'     =>      $settings['logo_type'],
				'text'     =>      ['text'=>$settings['logo_text']],
				'image'     =>      ['image'=>$settings['logo_image']],
			];
			$logo_args = array();
			if($logo_type === 'image'){
				$logo_args['image'] = $settings['logo_image']['url'];
			}
			$logo_args['title'] = $settings['logo_text'];
			$logo_args['url'] = $settings['logo_link'];

			$nav_args['logo'] = $logo_args;

		}
		if($settings['cat_menu_ac'] === "true"){
			$nav_args['menu']['mini_menu'] = true;
			$nav_args['menu']['mm_title'] = $settings['menu_title'];
			$nav_args['menu']['mm_id'] = $settings['cat_menu'];
		}
		if($settings['main_menu_ac'] === "false"){
			$nav_args['menu']['main_disable'] = true;
		}else{
			$nav_args['menu']['class'] = array('text-'.$settings['main_align']);
			$nav_args['menu']['id'] = (int)$settings['main_menu'];
		}
		$nav_args['trans'] = $settings['bg_trans'];

		$nav_args['style'] = $settings['nav_style'];
		$nav_args['cm'] = $settings['color_mode'];
		$nav_args['ubermenu'] = $settings['use_ubermenu'];
		ns_header_main_nav($nav_args);
	}

}
