<?php
namespace NegarshopElementor\Widgets;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_header_search_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return 'negarshop_header_search';
	}
	public function get_title() {
		return 'جستجوی پیشرفته';
	}
	public function get_icon() {
		return 'eicon-site-search';
	}
	public function get_categories() {
		return [ 'Negarshop_header' ];
	}
	protected function _register_controls() {
		$this->start_controls_section(
			'settings_section',
			[
				'label' => 'تنظیمات',
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'style',
			[
				'label'   =>  'طرح',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'style-1',
				'options' => [
					'style-1' => 'طرح اول',
                    'style-2' => 'طرح دوم',
					'style-3' => 'طرح سوم',
					'style-3 style-4' => 'طرح چهارم',
					'style-5' => 'طرح پنجم',
				],
			]
		);
		$this->add_control(
			'popup',
			[
				'label' =>  'حالت پاپ آپ',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'true' => 'فعال',
					'false' => 'غیرفعال',
				],
			]
		);
		$this->add_control(
			'color_mode',
			[
				'label' =>  'حالت رنگ',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'darken',
				'options' => [
					'darken' => 'تیره',
					'light' => 'روشن',
				],
			]
		);
		$this->add_control(
			'bg_color',
			[
				'label' =>  'رنگ زمینه',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'whiter',
				'options' => [
					'whiter' => 'سفید',
					'colored' => 'رنگی',
				],
			]
		);
		$this->add_control(
			'btn_color',
			[
				'label' =>  'رنگ دکمه',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'dark',
				'options' => [
					'light' => 'سفید',
					'dark' => 'تیره',
				],
			]
		);
		$this->add_control(
			'placeholder',
			[
				'label'=>   'متن جستجو',
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => 'جستجو در محصولات ...',
			]
		);
		$this->add_control(
			'ajax',
			[
				'label' =>  'جستجوی آژاکس',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'true' => 'فعال',
					'false' => 'غیرفعال',
				],
			]
		);
		$this->add_control(
			'post_type',
			[
				'label' =>  'جستجو در',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'product',
				'options' => [
					'product' => 'محصولات',
					'post' => 'مقالات',
				],
			]
		);
		$this->add_control(
			'filters',
			[
				'label' =>  'فیلتر های جستجو',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'true' => 'فعال',
					'false' => 'غیرفعال',
				],
			]
		);
		$this->add_control(
			'align',
			[
				'label' =>  'چینش',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'right',
				'options' => [
					'left' => 'چپ',
					'right' => 'راست',
					'center' => 'وسط',
				],
			]
		);

		$this->end_controls_section();

	}
	protected function render() {
		$settings = $this->get_settings_for_display();
		$settings['id'] = $this->get_id();

		$search_args = array();
		if($settings['ajax'] == "true"){$search_args['ajax'] = true;}
		if($settings['filters'] == "true"){$search_args['filter'] = true;}
		$search_args['bg-color'] = $settings['bg_color'];
		$search_args['style'] = $settings['style'];
		$search_args['text'] = $settings['placeholder'];
		$search_args['popup'] = $settings['popup'];
		$search_args['btn'] = $settings['btn_color'];
		$search_args['post_type'] = $settings['post_type'];
		ns_header_search($search_args,[
				'text-'.$settings['align'],
				$settings['color_mode'].'-color-mode'
			]
		);
	}

}
