<?php
namespace NegarshopElementor\Widgets;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_header_socials_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return 'negarshop_header_socials';
	}
	public function get_title() {
		return 'شبکه های اجتماعی';
	}
	public function get_icon() {
		return 'eicon-share';
	}
	public function get_categories() {
		return [ 'Negarshop_header' ];
	}
	protected function _register_controls() {
		$menus = wd_get_nav_menus_array();
		$this->start_controls_section(
			'settings_section',
			[
				'label' => 'تنظیمات',
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'style',
			[
				'label' =>  'طرح',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'style-1',
				'options' => [
					'style-1' => 'طرح اول',
					'style-2' => 'طرح دوم',
					'style-3' => 'طرح سوم',
				],
			]
		);
		$this->add_control(
			'align',
			[
				'label' =>  'چینش',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'left',
				'options' => [
					'left' => 'چپ',
					'right' => 'راست',
					'center' => 'وسط',
				],
			]
		);

		$repeater = new \Elementor\Repeater();

		$repeater->add_control(
			'title', [
				'label' =>  'عنوان',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);
		$repeater->add_control(
			'url', [
				'label' =>  'لینک',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);
		$repeater->add_control(
			'icon', [
				'label' =>  'آیکن',
				'type' => \Elementor\Controls_Manager::ICON,
				'default'   =>  'fa-smile-o'
			]
		);

		$this->add_control(
			'items',
			[
				'label' => 'لینک ها',
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [],
				'title_field' => '{{{ title }}}',
			]
		);
		$this->end_controls_section();

	}
	protected function render() {
		$settings = $this->get_settings_for_display();
		$settings['id'] = $this->get_id();

		ns_header_socials($settings['items'],[
			'text-'.$settings['align'],
			$settings['style']
		]);
	}

}
