<?php
namespace NegarshopElementor\Widgets;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_responsive_menu_Widget extends Widget_Base {
    public function get_name() {
        return 'negarshop_responsive_menu';
    }
    public function get_title() {
        return 'منوی همبرگری';
    }
    public function get_icon() {
        return 'eicon-nav-menu';
    }
    public function get_categories() {
        return [ 'Negarshop_responsive' ];
    }
    protected function _register_controls() {

        $menus = wd_get_nav_menus_array();
        $this->start_controls_section(
            'menu_content_section',
            [
                'label' => 'محتوای منو',
                'tab' => Controls_Manager::TAB_CONTENT,
            ]
        );

        $this->add_control(
            'menu',
            [
                'label' => 'انتخاب منو',
                'type' => Controls_Manager::SELECT,
                'options' => $menus,
            ]
        );


        $this->end_controls_section();

        $this->start_controls_section(
            'menu_style_section',
            [
                'label' => 'محتوای منو',
                'tab' => Controls_Manager::TAB_STYLE,
            ]
        );

        $this->add_control(
            'to-right',
            [
                'label' => 'چپ به راست',
                'type' => Controls_Manager::SWITCHER,
            ]
        );

        $this->add_control(
            'btn-color',
            [
                'label' => 'رنگ دکمه',
                'type' => Controls_Manager::COLOR,
                'default' => '#555',
                'selectors' => [
                    '{{WRAPPER}} .responsive-menu .toggle-menu' => 'color: {{VALUE}} !important',
                ],
            ]
        );
        $this->add_control(
            'icon',
            [
                'label' => __( 'Icon', 'text-domain' ),
                'type' => Controls_Manager::ICONS,
                'default' => [
                    'value' => 'far fa-bars',
                    'library' => 'solid',
                ],
            ]
        );

        $this->add_control(
            'btn-size',
            [
                'label' => 'سایز دکمه',
                'type' => Controls_Manager::NUMBER,
                'default' => 16,
                'selectors' => [
                    '{{WRAPPER}} .responsive-menu .toggle-menu' => 'font-size: {{VALUE}}px',
                ],
            ]
        );


        $this->end_controls_section();


    }
    protected function render() {
        $settings = $this->get_settings_for_display();

        $menu_args = array(
            'menu_class'     => 'categories-menu',
            'container'      => false
        );
        ?>
            <div class="responsive-menu">
                <button aria-label="<?= __("نمایش منو","negarshop") ?>" type="button" title="<?= __('نمایش منو',"negarshop") ?>" class="btn btn-transparent toggle-menu">
                    <?php echo '<i class="'.negarshop_fontawesome_425($settings['icon']['value']).'"></i>'; ?>
                </button>
                <div class="menu-popup<?php echo wc_string_to_bool($settings['to-right'])? ' to-right':''; ?>">
                <?php
                if(isset($settings['menu']) && !empty($settings['menu'])){
                    $menu_args['menu'] = (int) $settings['menu'];
                ?>
                <nav class="responsive-navbar">
                    <?php wp_nav_menu($menu_args); ?>
                </nav>
                <?php } ?>
                </div>
                <div class="overlay"></div>
            </div>
<?php
    }

}
