<?php
namespace NegarshopElementor\Widgets;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_responsive_search_Widget extends Widget_Base {
    public function get_name() {
        return 'negarshop_responsive_search';
    }
    public function get_title() {
        return 'جستجو';
    }
    public function get_icon() {
        return 'eicon-site-search';
    }
    public function get_categories() {
        return [ 'Negarshop_responsive' ];
    }
    protected function _register_controls() {

        $this->start_controls_section(
            'menu_style_section',
            [
                'label' => 'محتوای منو',
                'tab' => Controls_Manager::TAB_STYLE,
            ]
        );

	    $this->add_control(
		    'placeholder',
		    [
			    'label'=>   'متن جستجو',
			    'type' => \Elementor\Controls_Manager::TEXT,
			    'default' => 'جستجو در محصولات ...',
		    ]
	    );

        $this->add_control(
            'btn-color',
            [
                'label' => 'رنگ دکمه',
                'type' => Controls_Manager::COLOR,
                'default' => '#555',
                'selectors' => [
                    '{{WRAPPER}} .res-serach-btn' => 'color: {{VALUE}} !important',
                ],
            ]
        );
        $this->add_control(
            'icon',
            [
                'label' => __( 'Icon', 'text-domain' ),
                'type' => Controls_Manager::ICONS,
                'default' => [
                    'value' => 'far fa-search',
                    'library' => 'solid',
                ],
            ]
        );

        $this->add_control(
            'btn-size',
            [
                'label' => 'سایز دکمه',
                'type' => Controls_Manager::NUMBER,
                'default' => 16,
                'selectors' => [
                    '{{WRAPPER}} .res-serach-btn' => 'font-size: {{VALUE}}px',
                ],
            ]
        );


        $this->end_controls_section();


    }
    protected function render() {
        $settings = $this->get_settings_for_display();
        ?>
        <button class="res-serach-btn" id="res-search-show"><?php echo '<i class="'.negarshop_fontawesome_425($settings['icon']['value']).'"></i>'; ?></button>
        <div class="res-searchform">
            <form action="<?php echo site_url(); ?>">
                <input type="hidden" name="post_type" value="product" />
                <input type="search" name="s" value="<?php echo get_search_query(); ?>" class="text-input" placeholder="<?= $settings['placeholder'] ?? '' ?>">
                <button type="button" id="res-search-close"><i class="fal fa-times"></i></button>
            </form>
        </div>
        <?php
    }

}
