<?php
namespace NegarshopElementor\Widgets;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

class Elementor_shop_slider_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return 'negarshop_slider';
	}
	public function get_title() {
		return 'اسلایدر تصاویر';
	}
	public function get_icon() {
		return 'eicon-slider-push';
	}
	public function get_categories() {
		return [ 'Negarshop_main' ];
	}
	protected function _register_controls() {
		$this->start_controls_section(
			'style_section',
			[
				'label' => 'ظاهر',
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'color_t',
			[
				'label'   =>  'رنگ',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'default',
				'options' => [
					'default'   =>  'پیشفرض قالب',
					'custom'   =>  'دستی',
				],
			]
		);
		$this->add_control(
			'color',
			[
				'label' => 'رنگ جعبه',
				'type' => \Elementor\Controls_Manager::COLOR,
				'default' => '#00bfd6',
				'selectors' => [
					'{{WRAPPER}} a.archive' => 'background-color: {{VALUE}}',
					'{{WRAPPER}} .content-widget.slider-2 .carousel-indicators li.active' => 'background-color: {{VALUE}}',
				],
				'condition' => [
					'color_t' => 'custom',
				],
			]
		);
		$this->add_control(
			'slide_height',
			[
				'label'   =>  'برش عکس ها',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'true'   =>  'فعال',
					'false'   =>  'غیرفعال',
				],
			]
		);
		$this->add_control(
			'style',
			[
				'label'   =>  'طرح ابزارک',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'style-1',
				'options' => [
					'style-1'   =>  'طرح اول',
					'style-2'   =>  'طرح دوم',
				],
			]
		);
		$this->add_control(
			'animation',
			[
				'label'   =>  'انیمیشن اسلایدر',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'slide',
				'options' => [
					'slide'   =>  'اسلاید',
					'slide carousel-fade'   =>  'محو',
				],
			]
		);
		$this->end_controls_section();
		$this->start_controls_section(
			'content_section',
			[
				'label' => 'محتوا',
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'items_type',
			[
				'label' => 'محتوا',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'custom',
				'options' => [
					'custom'  => 'سفارشی',
					'products'  => 'محصولات',
				],
			]
		);
		// custom slides
		$repeater = new \Elementor\Repeater();

		$repeater->add_control(
			'title', [
				'label' => 'نام',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);
		$repeater->add_control(
			'link', [
				'label' => 'لینک',
				'type' => \Elementor\Controls_Manager::TEXT,
				'label_block' => true,
			]
		);
		$repeater->add_control(
			'photo', [
				'label' => 'تصویر',
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => \Elementor\Utils::get_placeholder_image_src(),
				],
			]
		);

		$this->add_control(
			'custom_slides',
			[
				'label' => 'اسلاید های سفارشی',
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [],
				'title_field' => '{{{ title }}}',
				'condition' => [
					'items_type' => 'custom',
				],
			]
		);

		// product slides
		$this->add_control(
			'products_type',
			[
				'label'   =>  'کوئری نمایش محصولات',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'news',
				'options' => [
					'news'   =>  'جدید ترین ها',
					'category'   =>  'دسته بندی خاص',
					'ids'   =>  'شناسه محصولات',
				],
				'condition' => [
					'items_type' => 'products',
				],
			]
		);
		$this->add_control(
			'woo_categories',
			[
				'label' =>  'دسته بندی ها',
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 0,
				'options' => cb_get_categories('product_cat'),
				'condition' => [
					'items_type' => 'products',
					'products_type' => 'category',
				],
			]
		);
		$this->add_control(
			'product_ids',
			[
				'label' =>  'شناسه ها',
				'placeholder'  =>  'مثال: 1,2,3,4',
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => '',
				'condition' => [
					'items_type' => 'products',
					'products_type' => 'ids',
				],
			]
		);
		$this->add_control(
			'products_count',
			[
				'label' =>  'تعداد جهت نمایش',
				'type' => \Elementor\Controls_Manager::NUMBER,
				'default' => 5,
				'condition' => [
					'items_type' => 'products',
				],
			]
		);


		$this->end_controls_section();

	}
	protected function render() {
		$settings = $this->get_settings_for_display();
		$settings['id'] = $this->get_id();
		$settings['items_type_picker']['custom']['slides'] = $settings['custom_slides'];
		$settings['items_type_picker']['products']['products_type_picker']['products_type'] = $settings['products_type'];
		$settings['items_type_picker']['products']['products_type_picker']['category']['woo_categories'] = $settings['woo_categories'];
		$settings['items_type_picker']['products']['products_type_picker']['ids']['product_ids'] = $settings['product_ids'];
		$settings['items_type_picker']['products']['products_count'] = $settings['products_count'];
		ns_page_widget_slider($settings,'elementor');
	}

}
